/*
 * linked list
 */

#ifndef LLIST_H
#define LLIST_H

#include <config.h>			/* autoconf */

#include <stdio.h>


typedef struct _node {			/* Double LL */
    void		*data;
    struct _node	*next,
			*prev;
    uint8_t		key_t;		/* key type */
    union {				/* key value */
	char		*str;
	int32_t		i;
	uint32_t	ui;
    } key;
} node;

enum {					/* node key types */
	LL_KEY_INT = 0,
	LL_KEY_UINT,
	LL_KEY_STR
};

typedef struct _llist {
    node		*head,
			*butt;
    /* compare function */
    /* node value delete function */
} llist;

					/* BTree */
typedef struct {
    node*		head;
    /* compare function */
    /* node value delete function */
} btree;

/* function prototypes */
node		*ll_append __P((llist *, void *));
llist		*ll_create __P((void));
void		ll_clear __P((llist **));
int		ll_count __P((llist *));
node		*ll_delete __P((llist *, node *));
node		*ll_find_name __P((llist *, char *));
char		*ll_find_val __P((llist *, char *));
node		*ll_insert_n __P((llist *, node *, node *));
node		*ll_next __P((llist *, node *));
node		*ll_node_n __P((llist *, int));
node		*ll_pop __P((llist *));
node		*ll_prev __P((node *));
node		*ll_push __P((llist *, void *));
node		*ll_shift __P((llist *));
int		ll_sort __P((llist *));

#define ll_empty(_LL_)	((_LL_)->head == NULL ? 1 : 0)

#endif /* LLIST_H */
