/*
 * linked list
 */

#ifndef LLIST_H
#define LLIST_H

#include <config.h>			/* autoconf */

#include <stdio.h>


typedef struct _node {			/* Double LL */
    void		*data;
    struct _node	*next,
			*prev;
    uint8_t		key_t;		/* key type */
    union {				/* key value */
	char		*str;
	int32_t		i;
	uint32_t	ui;
    } key;
} node;

enum {					/* node key types */
	LL_KEY_INT = 0,
	LL_KEY_UINT,
	LL_KEY_STR
};

typedef struct _llist {
    node		*head,
			*butt;
    /* compare function */
    /* node value delete function */
} llist;

					/* BTree */
typedef struct {
    node*		head;
    /* compare function */
    /* node value delete function */
} btree;

/* function prototypes */
node		*ll_append(llist *, void *);
llist		*ll_create(void);
void		ll_clear(llist **);
int		ll_count(llist *);
node		*ll_delete(llist *, node *);
node		*ll_find_name(llist *, char *);
char		*ll_find_val(llist *, char *);
node		*ll_insert_n(llist *, node *, node *);
node		*ll_next(llist *, node *);
node		*ll_node_n(llist *, int);
node		*ll_pop(llist *);
node		*ll_prev(node *);
node		*ll_push(llist *, void *);
node		*ll_shift(llist *);
int		ll_sort(llist *);

#define ll_empty(_LL_)	((_LL_)->head == NULL ? 1 : 0)

#endif /* LLIST_H */
