#ifndef LOG_H
#define LOG_H

#include <config.h>				/* autoconf */

extern	int	debug;				/* global logging switch */

extern	short 	_debug_depth;			/* global stack depth */

#define	DEBUG_IN	_debug_depth++;
#define DEBUG_RET	_debug_depth--;

#include <syslog.h>
#include <stdarg.h>

/* debugging switches */
#define	DEBUG_INIT		0x1		/* initialization */
#define	DEBUG_CONF		0x2		/* config lex/yacc */
#define	DEBUG_YY		0x4		/* yacc debugging */
#define	DEBUG_YY_VERB		0x8		/* yacc *noisey* debugging */
#define	DEBUG_LEX		0x10		/* lex debugging 16 */
#define	DEBUG_CALL		0x20		/* func calls / 32 */
#define	DEBUG_DB		0x40		/* DB operations / 64 */
#define	DEBUG_IPC		0x80		/* IPC ops / 128 */

#if 0		/* unused */
#define	DEBUG_			0x100		/* / 256 */
#define	DEBUG_			0x200		/* / 512 */
#define	DEBUG_			0x400		/* / 1024 */
#define	DEBUG_			0x800		/* / 2048 */
#define	DEBUG_			0x1000		/* / 4096 */
#endif
#define	DEBUG_M4		0x2000		/* m4 funcs / 8192 */
#if 0		/* unused */
#define	DEBUG_			0x4000		/* / 16384 */
#define	DEBUG_			0x8000		/* / 32768 */
#define	DEBUG_			0x10000		/* / 65536 */
#define	DEBUG_			0x20000		/* / 131072 */
#define	DEBUG_			0x40000		/* / 262144 */
#define	DEBUG_			0x80000		/* / 524288 */
#endif

#define BUF_SZ		LINE_MAX

/* function declarations */
RETSIGTYPE debug_off(void);
void debug_msg(char *, ...);
void log_msg(int, char *, ...);
void log_msgx(int, char *, ...);
void replace_pc(char *);
void start_syslog(char *, int, int);
void stop_syslog(void);

#endif /* LOG_H */
