/*-
 * Copyright (c) 1992, 1993
 *	The Regents of the University of California.  All rights reserved.
 * Copyright (c) 1996 BBN Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *from:	@(#)extern.h	8.1 (Berkeley) 5/31/93
 *	@(#) $Id: rcpd.h,v 1.2 2003/04/12 17:15:04 heas Exp $
 */

#include <netinet/in.h>
#include <sys/stat.h>

typedef struct {
	int cnt;
	char *buf;
} BUF;

void	 doit (struct sockaddr_in *);
#if defined(__STDC__) || defined(STDC_HEADERS)
void	 error (const char *, ...);
#else
#endif
void	 getstr (char *, int, char *);
int	 local_domain (char *);
char	*topdomain (char *);
void	 usage (void);

BUF	*allocbuf (BUF *, int, int);
void	 lostconn (int);
void	 run_err (const char *, ...);
void	 verifydir (char *);

void     rcp(int, char*[]);

int	 response (void);
void	 rsource (char *, struct stat *);
void	 sink (int, char *[]);
void	 source (int, char *[]);
void	 rcpusage (void);

extern struct sockaddr_in from;


#if !HAVE_STRERROR
char     *strerror(int);
#endif


extern int optind, opterr;
#if HAVE_OPTRESET
extern int optreset;
#endif

extern struct sockaddr_in from;
